import pygame

from doc.src import level, code_gen, diag, logic

screen = pygame.display.set_mode((0, 0), pygame.FULLSCREEN)
screen_size = screen.get_size()

pygame.init()

map_screen = pygame.Surface((900, 900))
map_screen.fill((255, 255, 255))
area = level.Map(map_screen, 30, 30, 30)

minds = []
players = []
for x in range(2):
    print("Program {}:".format(x + 1))
    mind = diag.Mind(screen)
    minds.append(mind)
    exe = logic.Executor(mind.initial)
    player = level.Player.from_map(area, logic.execute(exe), mind.gen.state)
    players.append(player)

end = False
player = 0
lock = False
n = 0
is_level = True
run = True
new_time = -100
while run:
    for event in pygame.event.get():
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                run = False
            if not end:
                if event.key == pygame.K_n and lock:
                    players[player].update()
                    n += 1
                    if n == 120:
                        area.reset()
                        n = 0
                        player = not player
                        new_time = pygame.time.get_ticks() + 300
                        if player == choice:
                            end = True
                            score = players[not choice].killed - players[choice].killed
                            if score > 0:
                                fin_text = "Congratulations! You saved {}"\
                                            " li{}!".format(score, "ves" if
                                            score > 1 else "fe")
                            elif score < 0:
                                fin_text = "You caused {} unnecessary "\
                                            "death{}!".format(-score,
                                            "s" if score < -1 else "")
                            else:
                                fin_text = "This was a troll question!!!"
                            font = pygame.font.Font(diag.FONT_PATH, 21)
                            img = font.render(fin_text, False, (255, 255, 255))
                if event.key == pygame.K_s:
                    is_level = not is_level
                if event.key == pygame.K_TAB and not lock:
                    player = not player
                if event.key == pygame.K_RETURN:
                    lock = True
                    choice = player
        elif event.type == pygame.MOUSEBUTTONDOWN and not is_level:
            minds[player].click(*event.pos)

    screen.fill((190, 190, 240))

    if end: 
        screen.fill((0, 0, 0))
        screen.blit(img, (0, 0))

    elif is_level:
        map_screen.fill(level.BG_COLOR)

        area.blit()
        players[player].blit()
        pygame.transform.scale(map_screen, screen_size, screen)
    
    else:
        minds[player].blit()

    if pygame.time.get_ticks() < new_time:
        screen.fill((255, 255, 255))

    pygame.display.flip()
